package com.ivy.homework.phonebook.bean;

import java.io.Serializable;

/**
 * contact of people. including a name\ address\phone number
 * 
 * @author eyandai
 */
public class Contact implements Serializable {

    /**
     * 
     */
    private static final long serialVersionUID = -2631389138572118562L;
    private String address;
    private String name;
    private String phoneNumber;

    public Contact() {
        super();
    }

    /**
     * 
     * @param name
     * @param address
     * @param phoneNumber
     */
    public Contact(String name, String address, String phoneNumber) {
        super();
        this.name = name;
        this.address = address;
        this.phoneNumber = phoneNumber;
    }

    /**
     * get address
     * 
     * @return address of contact
     */
    public String getAddress() {
        return address;
    }

    /**
     * get name
     * 
     * @return name of contact
     */
    public String getName() {
        return name;
    }

    /**
     * get phone number
     * 
     * @return phone Number of contact
     */
    public String getPhoneNumber() {
        return phoneNumber;
    }

    /**
     * set address
     * 
     * @param address
     *            address of contact
     */
    public void setAddress(String address) {
        this.address = address;
    }

    /**
     * set name
     * 
     * @param name
     *            name of contact
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * set phone number
     * 
     * @param phoneNumber
     *            phone number of contact
     */
    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((address == null) ? 0 : address.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((phoneNumber == null) ? 0 : phoneNumber.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        Contact other = (Contact) obj;
        if (address == null) {
            if (other.address != null)
                return false;
        } else if (!address.equals(other.address))
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        } else if (!name.equals(other.name))
            return false;
        if (phoneNumber == null) {
            if (other.phoneNumber != null)
                return false;
        } else if (!phoneNumber.equals(other.phoneNumber))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return "Contact [address=" + address + ", name=" + name + ", phoneNumber=" + phoneNumber + "]";
    }

}
