/**
 * Created : Dec 29, 2011
 */

package com.ivy.homework.phonebook.exception;

/**
 * <i>MyException</i> represent the general exception of the Address Book.
 * 
 * @author eyandai
 * 
 */
public final class MyException extends Exception {
    private static final long serialVersionUID = 1L;
    private final ErrorCode code;

    /**
     * Initial MyException.
     * 
     * @param code
     *            Error code.
     */
    public MyException(ErrorCode code) {
        this.code = code;
    }

    /**
     * Initial MyException.
     * 
     * @param code
     *            The {@link ErrorCode}
     * @param throwable
     *            Exception stack trace. If the throwable is another {@link MyException}, the <tt>MyException.external</tt> will be fetched as the external
     *            error of the new {@link MyException}
     */
    public MyException(ErrorCode code, Throwable throwable) {
        super(throwable);
        this.code = code;
    }

    /**
     * 
     * @return the {@link ErrorCode} of the MyException.
     */
    public ErrorCode getErrorCode() {
        return code;
    }

    @Override
    public String getMessage() {
        return code.getDescription();
    }
}
