/**
 * Created : Mar 1, 2012
 */
package com.ivy.homework.phonebook.impl;

import java.util.Iterator;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.ivy.homework.phonebook.Constants;
import com.ivy.homework.phonebook.bean.Contact;
import com.ivy.homework.phonebook.service.AddressBookView;

/**
 * Address Book display service.
 * 
 * @author eyandai
 */
public final class AddressBookViewCmdImpl implements AddressBookView {
    private final String START_STRING = "*************************************";
    private final String BLANK = "      ";
    private final String HEAD = BLANK + Constants.NAME + BLANK + Constants.ADDRESS + BLANK + Constants.PHONE;
    private static final Logger LOGGER = LoggerFactory.getLogger(AddressBookViewCmdImpl.class);

    public AddressBookViewCmdImpl() {
        super();
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ivy.homework.phonebook.impl.impl.AddressBookViewI#show(java.util.List, java.lang.String)
     */
    public void show(List<Contact> list, String message) {
        LOGGER.debug("show result");
        System.out.println(START_STRING);
        System.out.println(HEAD);
        for (Iterator<Contact> iterator = list.iterator(); iterator.hasNext();) {
            Contact contact = (Contact) iterator.next();
            System.out.println(BLANK + contact.getName() + BLANK + contact.getAddress() + BLANK + contact.getPhoneNumber());
        }
        System.out.println(message);
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ivy.homework.phonebook.impl.impl.AddressBookViewI#show(java.lang.String)
     */
    public void show(String message) {
        LOGGER.debug("show result");
        System.out.println(START_STRING);
        System.out.println(message);
    }
}
