/**
 * Created : Mar 7, 2012
 */
package com.ivy.homework.phonebook.service;

import org.apache.commons.cli.ParseException;

import com.ivy.homework.phonebook.exception.MyException;

/**
 * 
 * @author eyandai
 */
public interface ProcessorService {

    /**
     * set address book implements
     * 
     * @param view
     *            the address book service
     */
    void setAddressBook(AddressBookService addressBook);

    /**
     * set display implements
     * 
     * @param view
     *            the result display service
     */
    void setView(AddressBookView view);

    /**
     * to execute a command
     * 
     * @param string
     *            the input command from users.<br>
     * @throws ParseException
     *             when command is invalid, throw it.<br>
     */
    void execute(String string);

    /**
     * validate if the phone number is a valid phone number
     * 
     * @param phoneNumber
     *            phone number to validate
     * @throws MyException
     *             throw when phone number is invalid
     */
    void validatePhoneNumber(String phoneNumber) throws MyException;

    /**
     * show help information
     */
    void help();

    /**
     * stop proccess command
     */
    public void stop();

}