/**
 * Created : Mar 2, 2012
 */
package com.ivy.homework.phonebook;

import static org.mockito.Matchers.anyString;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.times;
import static org.mockito.Mockito.verify;

import java.io.BufferedReader;
import java.io.Reader;
import java.io.StringReader;

import org.junit.Before;
import org.junit.Test;

import com.ivy.homework.phonebook.service.ProcessorService;

/**
 * 
 * @author eyandai
 */
public class AddressBookExecutorTest {

    private AddressBookExecutor executor;
    private ProcessorService processorService;

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
        executor = new AddressBookExecutor();
        processorService = mock(ProcessorService.class);
        executor.setProcessor(processorService);
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.AddressBookExecutor#run()}.
     */
    @Test
    public void testQuit() throws Exception {
        Reader reader = new StringReader("quit");
        BufferedReader br = new BufferedReader(reader);
        executor.task(br);
        reader.close();
        br.close();
        verify(processorService, times(1)).stop();
    }

    @Test
    public void testCommand() throws Exception {
        Reader reader = new StringReader("create -n ivy -a address1 -p 13356897412 \n quit");
        BufferedReader br = new BufferedReader(reader);
        executor.task(br);
        reader.close();
        br.close();
        Thread.sleep(100);
        verify(processorService, times(1)).execute(anyString());
        verify(processorService, times(1)).stop();
    }

}
