/**
 * Created : Mar 5, 2012
 */
package com.ivy.homework.phonebook.exception;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

/**
 * 
 * @author eyandai
 */
public class MyExceptionTest {
    /**
     * Test method for {@link com.ivy.homework.phonebook.exception.MyException#MyException(com.ivy.homework.phonebook.exception.ErrorCode)}.
     */
    @Test
    public void testMyExceptionErrorCode() {
        MyException exception = new MyException(ErrorCode.INVALID_PHONE_NUMBER);
        assertEquals(exception.getErrorCode(), ErrorCode.INVALID_PHONE_NUMBER);
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.exception.MyException#MyException(com.ivy.homework.phonebook.exception.ErrorCode, java.lang.Throwable)}
     * .
     */
    @Test
    public void testMyExceptionErrorCodeThrowable() {
        NullPointerException e = new NullPointerException();
        MyException exception = new MyException(ErrorCode.INVALID_PHONE_NUMBER, e.getCause());
        assertEquals("fail to create MyException", exception.getCause(), e.getCause());
        assertEquals("fail to create MyException", exception.getErrorCode(), ErrorCode.INVALID_PHONE_NUMBER);
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.exception.MyException#getErrorCode()}.
     */
    @Test
    public void testGetErrorCode() {
        MyException exception = new MyException(ErrorCode.INVALID_PHONE_NUMBER);
        assertEquals("fail to create MyException", exception.getErrorCode(), ErrorCode.INVALID_PHONE_NUMBER);
    }

    @Test
    public void testGetMessage() {
        ErrorCode errorCode = new ErrorCode("10000", "test get message");
        MyException exception = new MyException(errorCode);
        assertEquals("fail to get error message", "test get message", exception.getMessage());
    }
}
