/**
 * Created : Mar 5, 2012
 */
package com.ivy.homework.phonebook.impl;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.List;

import org.junit.Before;
import org.junit.Test;

import com.ivy.homework.phonebook.bean.Contact;
import com.ivy.homework.phonebook.service.AddressBookService;

/**
 * 
 * @author eyandai
 */
public class AddressBookServiceImplTest {

    private AddressBookService addressBookServiceImpl;

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
        addressBookServiceImpl = new AddressBookServiceImpl();
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#newContact(com.ivy.homework.phonebook.impl.bean.Contact)}.
     */
    @Test
    public void testNewContact() {
        Contact contact = new Contact("ivy", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        assertEquals("fail to create new contact", contact, addressBookServiceImpl.searchByName("ivy").get(0));

    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#deleteContact(java.lang.String)}.
     */
    @Test
    public void testDeleteContact() {
        Contact contact = new Contact("ivy", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        addressBookServiceImpl.deleteContact("ivy");
        assertEquals("fail to delete contact", 0, addressBookServiceImpl.searchByName("ivy").size());
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#setContact(com.ivy.homework.phonebook.impl.bean.Contact)}.
     */
    @Test
    public void testSetContact() {
        Contact contact = new Contact("ivy", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        contact.setAddress("new street");
        addressBookServiceImpl.setContact(contact);
        assertEquals("fail to set contact", "new street", addressBookServiceImpl.searchByName("ivy").get(0).getAddress());
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#searchByName(java.lang.String)}.
     */
    @Test
    public void testSearchByName() {
        Contact contact = new Contact("ivy", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        assertEquals("fail to search contact by name", "street1", addressBookServiceImpl.searchByName("ivy").get(0).getAddress());
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#getAll()}.
     */
    @Test
    public void testGetAll() {
        Contact contact = new Contact("testGetAll", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        Contact contact2 = new Contact("testGetAll2", "street1", "12345");
        addressBookServiceImpl.newContact(contact2);
        List<Contact> list = addressBookServiceImpl.getAll();
        assertTrue("fail to search all contacts", list.contains(contact2));
        assertTrue("fail to search all contacts", list.contains(contact));
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#searchByAddress(java.lang.String)}.
     */
    @Test
    public void testSearchByAddress() {
        Contact contact = new Contact("ivy", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        assertEquals("fail to search contact by address", "ivy", addressBookServiceImpl.searchByAddress("street1").get(0).getName());
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressBookServiceImpl#searchByPhoneNumber(java.lang.String)}.
     */
    @Test
    public void testSearchByPhoneNumber() {
        Contact contact = new Contact("ivy", "street1", "12345");
        addressBookServiceImpl.newContact(contact);
        assertEquals("fail to search contact by address", "12345", addressBookServiceImpl.searchByPhoneNumber("12").get(0).getPhoneNumber());

    }

}
