/**
 * Created : Mar 2, 2012
 */
package com.ivy.homework.phonebook.impl;

import static org.junit.Assert.assertEquals;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import org.junit.Before;
import org.junit.Test;

import com.ivy.homework.phonebook.bean.Contact;

/**
 * 
 * @author eyandai
 */
public class AddressKeeperServiceXMLImplTest {

    private AddressKeeperServiceXMLImpl addressKeeperService;
    private String fileName = "/testphonebook.xml";

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
        addressKeeperService = new AddressKeeperServiceXMLImpl();
        URL url = getClass().getResource(fileName);
        addressKeeperService.setFileName(url.getPath());
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressKeeperServiceXMLImpl#getcontacts()}.
     */
    @Test
    public void testGetcontacts() throws Exception {
        Map<String, Contact> map = addressKeeperService.getContacts();
        assertEquals(2, map.size());
        assertEquals("fail to get contact", "aaa", map.get("aaa").getName());
        assertEquals("fail to get contact", "003", map.get("bbb").getPhoneNumber());
    }

    /**
     * Test method for {@link com.ivy.homework.phonebook.impl.impl.AddressKeeperServiceXMLImpl#saveContact(java.util.Map)}.
     */
    @Test
    public void testSavecontacts() {
        Contact contact1 = new Contact("aaa", "1,junit streets,java", "001");
        Contact contact2 = new Contact("bbb", "2,junit streets,java", "003");
        Map<String, Contact> map = new HashMap<String, Contact>();
        map.put("aaa", contact1);
        map.put("bbb", contact2);
        addressKeeperService.saveContacts(map);
        map.clear();
        map = addressKeeperService.getContacts();
        assertEquals("fail to save contacts", "aaa", map.get("aaa").getName());
        assertEquals("fail to save contacts", "003", map.get("bbb").getPhoneNumber());
    }

}
